test-lib.sh 4.9 KB
Newer Older
1 2 3 4 5 6 7
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano
#

# For repeatability, reset the environment to known value.
LANG=C
8
LC_ALL=C
9
PAGER=cat
10
TZ=UTC
11
export LANG LC_ALL PAGER TZ
12 13
EDITOR=:
VISUAL=:
14 15 16 17 18 19 20
unset AUTHOR_DATE
unset AUTHOR_EMAIL
unset AUTHOR_NAME
unset COMMIT_AUTHOR_EMAIL
unset COMMIT_AUTHOR_NAME
unset GIT_ALTERNATE_OBJECT_DIRECTORIES
unset GIT_AUTHOR_DATE
21 22
GIT_AUTHOR_EMAIL=author@example.com
GIT_AUTHOR_NAME='A U Thor'
23
unset GIT_COMMITTER_DATE
24 25
GIT_COMMITTER_EMAIL=committer@example.com
GIT_COMMITTER_NAME='C O Mitter'
26 27 28 29 30 31 32
unset GIT_DIFF_OPTS
unset GIT_DIR
unset GIT_EXTERNAL_DIFF
unset GIT_INDEX_FILE
unset GIT_OBJECT_DIRECTORY
unset SHA1_FILE_DIRECTORIES
unset SHA1_FILE_DIRECTORY
33 34
export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
35
export EDITOR VISUAL
36

37
case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
38 39 40 41 42 43 44 45
	1|2|true)
		echo "* warning: Some tests will not work if GIT_TRACE" \
			"is set as to trace on STDERR ! *"
		echo "* warning: Please set GIT_TRACE to something" \
			"other than 1, 2 or true ! *"
		;;
esac

46 47 48 49 50 51 52 53 54
# Each test should start with something like this, after copyright notices:
#
# test_description='Description of this test...
# This test checks if command xyzzy does the right thing...
# '
# . ./test-lib.sh

error () {
	echo "* error: $*"
55
	trap - exit
56 57 58 59 60 61 62 63 64 65 66 67 68 69 70
	exit 1
}

say () {
	echo "* $*"
}

test "${test_description}" != "" ||
error "Test script did not set test_description."

while test "$#" -ne 0
do
	case "$1" in
	-d|--d|--de|--deb|--debu|--debug)
		debug=t; shift ;;
J
Junio C Hamano 已提交
71 72
	-i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
		immediate=t; shift ;;
73 74 75 76 77
	-h|--h|--he|--hel|--help)
		echo "$test_description"
		exit 0 ;;
	-v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
		verbose=t; shift ;;
78 79
	--no-python)
		no_python=t; shift ;;
80 81 82 83 84
	*)
		break ;;
	esac
done

85
exec 5>&1
86 87 88 89 90 91 92 93 94 95
if test "$verbose" = "t"
then
	exec 4>&2 3>&1
else
	exec 4>/dev/null 3>/dev/null
fi

test_failure=0
test_count=0

96 97
trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit

98

J
Junio C Hamano 已提交
99 100 101 102
# You are not expected to call test_ok_ and test_failure_ directly, use
# the text_expect_* functions instead.

test_ok_ () {
103
	test_count=$(expr "$test_count" + 1)
104
	say "  ok $test_count: $@"
105 106
}

J
Junio C Hamano 已提交
107
test_failure_ () {
108 109
	test_count=$(expr "$test_count" + 1)
	test_failure=$(expr "$test_failure" + 1);
110 111 112
	say "FAIL $test_count: $1"
	shift
	echo "$@" | sed -e 's/^/	/'
113
	test "$immediate" = "" || { trap - exit; exit 1; }
J
Junio C Hamano 已提交
114 115 116 117
}


test_debug () {
118
	test "$debug" = "" || eval "$1"
119 120
}

121 122 123 124 125 126
test_run_ () {
	eval >&3 2>&4 "$1"
	eval_ret="$?"
	return 0
}

127
test_expect_failure () {
128
	test "$#" = 2 ||
129 130
	error "bug in the test script: not 2 parameters to test-expect-failure"
	say >&3 "expecting failure: $2"
131 132
	test_run_ "$2"
	if [ "$?" = 0 -a "$eval_ret" != 0 ]
133
	then
J
Junio C Hamano 已提交
134
		test_ok_ "$1"
135 136
	else
		test_failure_ "$@"
137 138 139 140
	fi
}

test_expect_success () {
141
	test "$#" = 2 ||
142 143
	error "bug in the test script: not 2 parameters to test-expect-success"
	say >&3 "expecting success: $2"
144 145
	test_run_ "$2"
	if [ "$?" = 0 -a "$eval_ret" = 0 ]
146
	then
J
Junio C Hamano 已提交
147
		test_ok_ "$1"
148
	else
J
Junio C Hamano 已提交
149
		test_failure_ "$@"
150 151 152
	fi
}

153 154 155 156 157 158 159 160 161 162 163 164 165
test_expect_code () {
	test "$#" = 3 ||
	error "bug in the test script: not 3 parameters to test-expect-code"
	say >&3 "expecting exit code $1: $3"
	test_run_ "$3"
	if [ "$?" = 0 -a "$eval_ret" = "$1" ]
	then
		test_ok_ "$2"
	else
		test_failure_ "$@"
	fi
}

166 167 168 169 170 171 172 173 174 175 176 177 178 179 180
# Most tests can use the created repository, but some amy need to create more.
# Usage: test_create_repo <directory>
test_create_repo () {
	test "$#" = 1 ||
	error "bug in the test script: not 1 parameter to test-create-repo"
	owd=`pwd`
	repo="$1"
	mkdir "$repo"
	cd "$repo" || error "Cannot setup test environment"
	"$GIT_EXEC_PATH/git" init-db --template=$GIT_EXEC_PATH/templates/blt/ 2>/dev/null ||
	error "cannot run git init-db -- have you built things yet?"
	mv .git/hooks .git/hooks-disabled
	cd "$owd"
}
	
181
test_done () {
182
	trap - exit
183
	case "$test_failure" in
184
	0)
185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205
		# We could:
		# cd .. && rm -fr trash
		# but that means we forbid any tests that use their own
		# subdirectory from calling test_done without coming back
		# to where they started from.
		# The Makefile provided will clean this test area so
		# we will leave things as they are.

		say "passed all $test_count test(s)"
		exit 0 ;;

	*)
		say "failed $test_failure among $test_count test(s)"
		exit 1 ;;

	esac
}

# Test the binaries we have just built.  The tests are kept in
# t/ subdirectory and are run in trash subdirectory.
PATH=$(pwd)/..:$PATH
J
Johannes Schindelin 已提交
206
GIT_EXEC_PATH=$(pwd)/..
207 208 209 210 211 212 213
export PATH GIT_EXEC_PATH

# Similarly use ../compat/subprocess.py if our python does not
# have subprocess.py on its own.
PYTHON=`sed -e '1{
	s/^#!//
	q
J
Junio C Hamano 已提交
214
}' ../git-merge-recursive-old` || {
215 216
	error "You haven't built things yet, have you?"
}
217 218 219 220
"$PYTHON" -c 'import subprocess' 2>/dev/null || {
	PYTHONPATH=$(pwd)/../compat
	export PYTHONPATH
}
221 222
GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
export GITPERLLIB
223 224 225
test -d ../templates/blt || {
	error "You haven't built things yet, have you?"
}
226 227 228 229

# Test repository
test=trash
rm -fr "$test"
230 231
test_create_repo $test
cd "$test"